﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Diagnostics;

namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        int[] al1 = new int[1000000];
        ulong[] al2 = new ulong[1000000];

        public Form1()
        {
            InitializeComponent();
        }

        private static void PerfOfRandom(Random random, int loopCount)
        {
            Stopwatch st = new Stopwatch();
            st.Start();

            for (int i = 0; i < loopCount; i++)
            {
                random.Next();
            }

            st.Stop();
            Console.WriteLine(loopCount + " elapsed: " + st.ElapsedMilliseconds);
        }

        private static void PerfOfMT(int loopCount)
        {
            Stopwatch st = new Stopwatch();
            st.Start();

            for (int i = 0; i < loopCount; i++)
            {
                Well512.Next();
            }

            st.Stop();
            Console.WriteLine(loopCount + " elapsed: " + st.ElapsedMilliseconds);
        }

        private void button1_Click(object sender, EventArgs e)
        {
            Graphics dc = this.CreateGraphics();
            this.Show();
            Pen BluePen = new Pen(Color.Blue, 1);

            dc.Clear(Color.White);


            Random random = new Random((int)DateTime.Now.Ticks);

            for (int i = 0; i < 1000000; i++)
            {
                int rand1 = random.Next(600);
                ulong rand2 = Well512.Next(600);

                al1[i] = rand1;
                al2[i] = rand2;
            }

            for (int i = 0; i < 999999; i++)
            {
                dc.DrawEllipse(BluePen, al1[i], al1[i+1], 1, 1);
                dc.DrawEllipse(BluePen, al2[i] + 700, al2[i+1], 1, 1);
            }
        }
    }

    public class Well512
    {
        static uint[] state = new uint[16];
        static uint index = 0;

        static Well512()
        {
            Random random = new Random((int)DateTime.Now.Ticks);

            for (int i = 0; i < 16; i++)
            {
                state[i] = (uint)random.Next();
            }
        }

        internal static uint Next(int minValue, int maxValue)
        {
            return (uint)((Next() % (maxValue - minValue)) + minValue);
        }

        public static uint Next(uint maxValue)
        {
            return Next() % maxValue;
        }

        public static uint Next()
        {
            uint a, b, c, d;

            a = state[index];
            c = state[(index + 13) & 15];
            b = a ^ c ^ (a << 16) ^ (c << 15);
            c = state[(index + 9) & 15];
            c ^= (c >> 11);
            a = state[index] = b ^ c;
            d = a ^ ((a << 5) & 0xda442d24U);
            index = (index + 15) & 15;
            a = state[index];
            state[index] = a ^ b ^ d ^ (a << 2) ^ (b << 18) ^ (c << 28);

            return state[index];
        }

    }
}
